<?php
ini_set('display_errors', 1);

require_once '../../resources/base_path_include.php';
require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources.'lib/validate_function.php';
require_once $base_path_to_learning.'user_management/authenticate.php';
require_once $base_path_to_learning.'functions/common_functions.php';
//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';

$postdata = json_decode(file_get_contents("php://input"), true);
//print_r($postdata);
checkIfNoPhpContentsReceive();

if (!isset($postdata['institution_id']) or !checkIfIssetAndNotEmpty($postdata['institution_id']) or !isset($postdata['class_id']) or !checkIfIssetAndNotEmpty($postdata['class_id']) or  !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or 
!isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or !isset($postdata['jwt_token']) or  !isset($postdata['jwt_token'])) {
    errorreturn("All * fields are required.");
}


validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
//then workspace_id is iin decodede data of jwt use from there
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id,['superadmin','admin'], null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}
function getSpecificClass($conn_rjllearning_specific,$institution_id,$class_id) {
    // reeturns all data from the specific row of the profile
    $sql = $conn_rjllearning_specific->prepare("SELECT * FROM  class_info where id = ? and institution_id =?");
    $sql->execute(array($class_id,$institution_id));
    $rows = $sql->fetchAll();

    if (count($rows) == 1) {
        
        $branch_id = $rows[0]['branch_id'];
    
        $branches = []; // Initialize branches array
        
        if ($branch_id == 'all') {
           $branches[] = array('branch_id' => $branch_id,'name' =>ucwords($branch_id));
        } else {
            // $imploded_branchids = implode(',', $branch_id); // Convert array to comma-separated string
            // print_R($imploded_branchids);
            $sql = "SELECT * FROM branch WHERE institution_id = ? AND id IN ($branch_id) and status = ?";
            $array_params = [$institution_id,'1']; // Add institution_id to parameters
            $stmt = $conn_rjllearning_specific->prepare($sql);
            $stmt->execute($array_params);
            $branch_rows = $stmt->fetchAll();
        
            foreach ($branch_rows as $branch) {
                $branches[] = array('branch_id' => $branch['id'], 'name' => $branch['name']);
            }
        }
        
        
        
        return array('class_id' => $rows[0]['id'],'branch_id' =>$branches,'class_name' => $rows[0]['classname'], 'class_order' => $rows[0]['class_order']);
      
    }else{
          errorreturn("Enter Invalid Classs");
    }

}


if($postdata['function_type']  == "fetch_specific_class") {  
    
    $institution_id = trim($postdata['institution_id']);
    $class_id = trim($postdata['class_id']);
   $check_academic_confirmation = CheckAcademicSession($conn_rjllearning_specific,$institution_id);
    if($check_academic_confirmation != true){
         errorreturn("Access denied. Academic session not active.");
    }

    $success['data'] = getSpecificClass($conn_rjllearning_specific,$institution_id,$class_id);
    successreturn($success);
      
}

